/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

Nome: 7777_PLATMP_ATUALIZA_RECEITA
                                                                            
Descrio:                                                                 
Script temporrio para atualizao dos campos
QTUNIDESTPR e QTBRUTAPR da tabela RECEPADR,
QTUNIDESTLO e QTBRUTALO da tabela RECEFILI e  
QTUNIDESTSE e QTBRUTASE da tabela RECESERV 

Criao:                                                                   
09/02/00 - Andr Rodrigo
*/

DECLARE V_CDFILIAL VARCHAR2(4);

BEGIN

-- RECEITA PADRO

   SELECT MAX(CDFILIAL) INTO V_CDFILIAL
   FROM PARAMGERAL;

   UPDATE
      (SELECT
          RP.QTPRODPRAT,
          RP.SGUNIDADE,
          RP.CDPRODUTO,
          PD.SGUNIDADE  AS SGUNIDPROD,
          RP.QTUNIDESTPR
       FROM
          RECEPADR RP,
          PRODUTO  PD
       WHERE
          (PD.CDPRODUTO = RP.CDPRODUTO) AND
          (QTUNIDESTPR IS NULL))
   SET
      QTUNIDESTPR = QTDE_UNIDADE_ESTOQUE(QTPRODPRAT,
                                         SGUNIDADE,
                                         CDPRODUTO,
                                         SGUNIDPROD);


   UPDATE
      (SELECT
          VRPEFATCOCPR,
          VRPEFATCORPR,
          QTPRODPRAT,
          QTBRUTAPRUNR
       FROM
          RECEPADR
       WHERE
          QTBRUTAPRUNR IS NULL)
   SET
      QTBRUTAPRUNR = QTDE_BRUTA_PRODUTO(V_CDFILIAL,
                                        QTPRODPRAT,
                                        VRPEFATCOCPR,
                                        VRPEFATCORPR);


   UPDATE
      (SELECT
          RP.QTBRUTAPR,
          RP.SGUNIDADE,
          RP.CDPRODUTO,
          PD.SGUNIDADE  AS SGUNIDPROD,
          RP.QTBRUTAPRUNR
       FROM
          RECEPADR RP,
          PRODUTO  PD
       WHERE
          (PD.CDPRODUTO = RP.CDPRODUTO) AND
          (QTBRUTAPR IS NULL))
   SET
      QTBRUTAPR = QTDE_UNIDADE_ESTOQUE(QTBRUTAPRUNR,
                                       SGUNIDADE,
                                       CDPRODUTO,
                                       SGUNIDPROD);


   UPDATE RECEPADR
   SET VRPEFATNUTPR = 100,
       QTCALCNUTRPR = QTBRUTAPR
   WHERE (QTCALCNUTRPR IS NULL);


-- RECEITA LOCAL

   UPDATE
      (SELECT
          RF.QTPRODRECLOC,
          RF.SGUNIDADE,
          RF.CDPRODUTO,
          PD.SGUNIDADE  AS SGUNIDPROD,
          RF.QTUNIDESTLO
       FROM
          RECEFILI RF,
          PRODUTO  PD
       WHERE
          (PD.CDPRODUTO = RF.CDPRODUTO) AND
          (QTUNIDESTLO IS NULL))
   SET
      QTUNIDESTLO = QTDE_UNIDADE_ESTOQUE(QTPRODRECLOC,
                                         SGUNIDADE,
                                         CDPRODUTO,
                                         SGUNIDPROD);

   UPDATE
      (SELECT
          CDFILIAL,
          VRPEFATCOCLO,
          VRPEFATCORLO,
          QTPRODRECLOC,
          QTBRUTALOUNR
       FROM
          RECEFILI
       WHERE
          QTBRUTALOUNR IS NULL)
   SET
      QTBRUTALOUNR = QTDE_BRUTA_PRODUTO(CDFILIAL,
                                        QTPRODRECLOC,
                                        VRPEFATCOCLO,
                                        VRPEFATCORLO);

   UPDATE
      (SELECT
          RP.QTBRUTALO,
          RP.SGUNIDADE,
          RP.CDPRODUTO,
          PD.SGUNIDADE  AS SGUNIDPROD,
          RP.QTBRUTALOUNR
       FROM
          RECEFILI RP,
          PRODUTO  PD
       WHERE
          (PD.CDPRODUTO = RP.CDPRODUTO) AND
          (QTBRUTALO IS NULL))
   SET
      QTBRUTALO = QTDE_UNIDADE_ESTOQUE(QTBRUTALOUNR,
                                       SGUNIDADE,
                                       CDPRODUTO,
                                       SGUNIDPROD);


   UPDATE RECEFILI
   SET VRPEFATNUTLO = 100,
       QTCALCNUTRLO = QTBRUTALO
   WHERE (QTCALCNUTRLO IS NULL);


-- RECEITA POR SERVIO

   UPDATE
      (SELECT
          RS.QTPRODRECSER,
          RS.SGUNIDADE,
          RS.CDPRODUTO,
          PD.SGUNIDADE  AS SGUNIDPROD,
          RS.QTUNIDESTSE
       FROM
          RECESERV RS,
          PRODUTO  PD
       WHERE
          (PD.CDPRODUTO = RS.CDPRODUTO) AND
          (QTUNIDESTSE IS NULL))
   SET
      QTUNIDESTSE = QTDE_UNIDADE_ESTOQUE(QTPRODRECSER,
                                         SGUNIDADE,
                                         CDPRODUTO,
                                         SGUNIDPROD);


   UPDATE
      (SELECT
          CDFILIAL,
          VRPEFATCOCSE,
          VRPEFATCORSE,
          QTPRODRECSER,
          QTBRUTASEUNR
       FROM
          RECESERV
       WHERE
          QTBRUTASEUNR IS NULL)
   SET
      QTBRUTASEUNR = QTDE_BRUTA_PRODUTO(CDFILIAL,
                                        QTPRODRECSER,
                                        VRPEFATCOCSE,
                                        VRPEFATCORSE);

   UPDATE
      (SELECT
          RP.QTBRUTASE,
          RP.SGUNIDADE,
          RP.CDPRODUTO,
          PD.SGUNIDADE  AS SGUNIDPROD,
          RP.QTBRUTASEUNR
       FROM
          RECESERV RP,
          PRODUTO  PD
       WHERE
          (PD.CDPRODUTO = RP.CDPRODUTO) AND
          (QTBRUTASE IS NULL))
   SET
      QTBRUTASE = QTDE_UNIDADE_ESTOQUE(QTBRUTASEUNR,
                                       SGUNIDADE,
                                       CDPRODUTO,
                                       SGUNIDPROD);

   UPDATE RECESERV
   SET VRPEFATNUTSE = 100,
       QTCALCNUTRSE = QTBRUTASE
   WHERE (QTCALCNUTRSE IS NULL);


   UPDATE COMPCARD
   SET NRORDPRATCAR = NRSEQPRATCAR
   WHERE NRORDPRATCAR IS NULL;

   UPDATE CNFCAMES
   SET NRORDCNFMES = NRSEQCNFMES
   WHERE NRORDCNFMES IS NULL;

   UPDATE CONFCARD
   SET NRORDCNFCARD = NRSEQCNFCARD
   WHERE NRORDCNFCARD IS NULL;

   UPDATE INTERNAC
   SET CDLEITO = (SELECT L.CDLEITO
                  FROM INTERLEITO L
                  WHERE
                     INTERNAC.CDPACIENTE = L.CDPACIENTE AND
                     INTERNAC.DTINTERNA  = L.DTINTERNA  AND
                     L.DTDESOLEITO IS NULL)
   WHERE (DTALTA IS NULL) AND
         (CDLEITO IS NULL);

   UPDATE LEITO
   SET IDOCUPLEITO = (SELECT
                        'S'
                      FROM
                         INTERNAC I
                      WHERE
                         I.CDLEITO = LEITO.CDLEITO AND
                         DTALTA IS NULL);

   UPDATE LEITO
   SET IDOCUPLEITO = 'N'
   WHERE
      (IDOCUPLEITO IS NULL OR
      IDOCUPLEITO <> 'S');

   UPDATE PACIENTE
   SET NMPACIUPPER = UPPER(NMPACIENTE)
   WHERE NMPACIUPPER IS NULL;

   COMMIT;
END;
/
