<?php
namespace Teknisa\Model\Teknisa\Repositories;


class Solipatchpro extends \Doctrine\ORM\EntityRepository {
    
    public function getItemsTask($initialPatch, $endPatch)
    {
        $query = <<<SQL
        SELECT TSI.NRSOLISERV, TSI.NRTAREFA, TSI.CDITEMTRAB, TSI.NMITEMTRAB, TSI.CDREDUITTRAB, DES.DSSOLISERV
          FROM (SELECT T.NRSOLISERV, I.NRTAREFA, I.CDITEMTRAB, IT.NMITEMTRAB, IT.CDREDUITTRAB
                  FROM ITEMTAREFA I
                  JOIN ITEMTRAB IT ON I.CDITEMTRAB = IT.CDITEMTRAB
                  JOIN TAREFA T ON I.NRTAREFA = T.NRTAREFA
                  JOIN DIRFONTITEMTRAB D ON IT.CDITEMTRAB = D.CDITEMTRAB
                 WHERE I.NRTAREFA IN (SELECT NRTAREFA
                                        FROM TAREFA 
                                       WHERE NRSOLISERV IN (SELECT SPP.NRSOLISERV
                                        FROM SOLIPATCHPRO SPP, SOLISERV SOL
                                       WHERE SPP.NRSOLISERV = SOL.NRSOLISERV
                                             AND (SPP.CDVERPRODUTO||SPP.CDRELVERPROD||SPP.CDPATCHVERPR >= :P_PATCHINI)
                                              AND (SPP.CDVERPRODUTO||SPP.CDRELVERPROD||SPP.CDPATCHVERPR <= :P_PATCHFIN)))
              GROUP BY T.NRSOLISERV, I.NRTAREFA, I.CDITEMTRAB, IT.NMITEMTRAB, IT.CDREDUITTRAB) TSI 
          JOIN DESCSOLI DES ON TSI.NRSOLISERV = DES.NRSOLISERV
SQL;
        $params = array(
            "P_PATCHINI" => $initialPatch,
            "P_PATCHFIN" => $endPatch
        );
        
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
    
    public function getProductVersionsByPatchesInterval($initialPatch, $endPatch)
    {
        
        $query = <<<SQL
        SELECT PRO.CDARVPROD, PRO.NMPRODUTO, 
               MIN(SPP.CDVERPRODUTO||'.'||SPP.CDRELVERPROD||'.'||SPP.CDPATCHVERPR) AS CDVERSAOINI, 
               MAX(SPP.CDVERPRODUTO||'.'||SPP.CDRELVERPROD||'.'||SPP.CDPATCHVERPR) AS CDVERSAOFIM 
          FROM PRODUTO PRO, SOLIPATCHPRO SPP
         WHERE SPP.CDPRODGRUP = PRO.CDPRODUTO
           AND (SPP.CDVERPRODUTO||SPP.CDRELVERPROD||SPP.CDPATCHVERPR > :P_PATCHINI)
           AND (SPP.CDVERPRODUTO||SPP.CDRELVERPROD||SPP.CDPATCHVERPR <= :P_PATCHFIN)
      GROUP BY PRO.CDARVPROD, PRO.NMPRODUTO
      ORDER BY PRO.CDARVPROD
SQL;
        
        $params = array(
            "P_PATCHINI" => $initialPatch,
            "P_PATCHFIN" => $endPatch
        );
        
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
    
}